/* $Id: polrec.cpp 103 2008-08-07 14:08:33Z dirk $ */

/* GCL - Geodetic Computation Library
 * Copyright (C) 2005 Dirk Stallmann
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
#include <cmath>

namespace GCL
{

// convert polar into rectagular coordinates

void pol_to_rec(double psi, double l, double r,
double& x, double& y, double& z)
{
	double r_xy = r * cos(psi);	// xy-component of r
	x = r_xy * cos(l);
	y = r_xy * sin(l);
	z = r * sin(psi);
}

// convert rectagular into polar coordinates

void rec_to_pol(double x, double y, double z,
double& psi, double& l, double& r)
{
	r = sqrt(x * x + y * y + z * z);
	psi = asin(z / r);
	l = atan2(y, x);
}

} // namespace GCL
